/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const te=require("react"),p=require("@progress/kendo-react-form"),C=require("@progress/kendo-react-labels"),oe=require("@progress/kendo-react-intl"),E=require("@progress/kendo-react-common"),v=require("./AxesEditor.js"),ne=require("./FieldsEditor.js"),o=require("../messages/index.js"),d=require("../hooks/usePivotConfiguratorEditor.js"),se=require("../shared/PivotGridConfiguratorEditorEventsContext.js"),re=require("../shared/PivotGridConfiguratorEditorStateContext.js");function ae(r){const x=Object.create(null,{[Symbol.toStringTag]:{value:"Module"}});if(r){for(const c in r)if(c!=="default"){const A=Object.getOwnPropertyDescriptor(r,c);Object.defineProperty(x,c,A.get?A:{enumerable:!0,get:()=>r[c]})}}return x.default=r,Object.freeze(x)}const e=ae(te),w=e.forwardRef((r,x)=>{const{onFieldsEditorFieldCheck:c,onFieldsEditorFieldCheckAction:A=a.onFieldsEditorFieldCheckAction,onFieldsEditorFieldExpand:b,onFieldsEditorFieldExpandAction:R=a.onFieldsEditorFieldExpandAction,onAxisFilterFieldExpand:I,onAxisFilterFieldsExpandChange:N}=r,n={onFieldsEditorFieldCheck:c,onFieldsEditorFieldCheckAction:A,horizontal:a.horizontal,axesEditor:a.axesEditor,...r},[k,G]=E.useCustomComponent(n.fieldsLabel||a.fieldsLabel),[_,S]=E.useCustomComponent(n.fieldsEditor||a.fieldsEditor),[q,z]=E.useCustomComponent(n.columnAxesLabel||a.columnAxesLabel),[D,U]=E.useCustomComponent(n.columnAxesEditor||a.columnAxesEditor),[V,Z]=E.useCustomComponent(n.rowAxesLabel||a.rowAxesLabel),[j,B]=E.useCustomComponent(n.rowAxesEditor||a.rowAxesEditor),[H,K]=E.useCustomComponent(n.measureAxesLabel||a.measureAxesLabel),[J,Q]=E.useCustomComponent(n.measureAxesEditor||a.measureAxesEditor),W=e.useRef(null),u=e.useRef(null),g=oe.useLocalization(),[s,i]=d.usePivotConfiguratorEditor(n,u);e.useImperativeHandle(u,()=>({element:W.current,props:n,state:s})),e.useImperativeHandle(x,()=>u.current);const F=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:"columnAxes"})},L=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:null})},h=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:"rowAxes"})},y=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:null})},M=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:"measureAxes"})},T=()=>{s.dragItem&&i({type:d.PIVOT_CONFIGURATOR_ACTION.setDropZone,payload:null})},X=t=>{const m={target:t.target,currentTarget:u.current,value:t.value,syntheticEvent:t.syntheticEvent};if(R){const l=R(m,n,s);l&&(Array.isArray(l)?l.filter(Boolean).map(f=>f&&i({...f},t.syntheticEvent)):i({...l},t.syntheticEvent))}b&&b({target:t.target,currentTarget:u.current,value:t.value,syntheticEvent:t.syntheticEvent})},Y=t=>{const m={target:t.target,currentTarget:u.current,value:t.value,syntheticEvent:t.syntheticEvent};if(A){const l=A(m,n,s);l&&(Array.isArray(l)?l.filter(Boolean).map(f=>f&&i({...f},t.syntheticEvent)):i({...l},t.syntheticEvent))}c&&c(m)},$=t=>{const m={target:t.target,currentTarget:u.current,value:t.value,syntheticEvent:t.syntheticEvent};I&&I(m)},ee=t=>{const m={target:t.target,currentTarget:u.current,value:t.value,syntheticEvent:t.syntheticEvent};N&&N(m)},O=n.horizontal?"div":e.Fragment,P=n.horizontal?{className:"k-form-field-wrapper"}:{};return e.createElement(se.PivotGridConfiguratorEditorEventsContext.Provider,{value:{onAxisFilterFieldExpand:$,onAxisFilterFieldsExpandChange:ee}},e.createElement(re.PivotGridConfiguratorEditorStateContext.Provider,{value:[s,i]},e.createElement(O,{...P},e.createElement("div",{className:"k-form-field"},e.createElement(k,{name:"",component:C.Label,...G},g.toLanguageString(o.configuratorEditorSearchTitle,o.messages[o.configuratorEditorSearchTitle]))),e.createElement("div",{className:"k-form-field"},e.createElement("div",{className:"k-fields-list-wrapper"},e.createElement(_,{data:n.data,onExpand:X,onCheck:Y,columnAxes:s.columnAxes,rowAxes:s.rowAxes,measureAxes:s.measureAxes,...S})))),e.createElement(O,{...P},e.createElement("div",{className:"k-form-field",onMouseEnter:F,onMouseLeave:L},e.createElement(p.Field,{name:"columnAxes",field:"columnAxes",component:q,...z},g.toLanguageString(o.configuratorColumnsTitle,o.messages[o.configuratorColumnsTitle]))),n.valueGetter("columnAxes").length?e.createElement(p.Field,{name:"columnAxes",field:"columnAxes",component:D,onMouseEnter:F,onMouseLeave:L,className:"k-column-fields",...U}):e.createElement("div",{className:"k-settings-description",onMouseEnter:F,onMouseLeave:L},g.toLanguageString(o.configuratorMissingFields,o.messages[o.configuratorMissingFields])),e.createElement("div",{className:"k-form-field",onMouseEnter:h,onMouseLeave:y},e.createElement(p.Field,{name:"rowAxes",field:"rowAxes",component:V,...Z},g.toLanguageString(o.configuratorRowsTitle,o.messages[o.configuratorRowsTitle]))),n.valueGetter("rowAxes").length?e.createElement(p.Field,{name:"rowAxes",field:"rowAxes",component:j,onMouseEnter:h,onMouseLeave:y,className:"k-column-fields",...B}):e.createElement("div",{className:"k-settings-description",onMouseEnter:h,onMouseLeave:y},g.toLanguageString(o.configuratorMissingFields,o.messages[o.configuratorMissingFields]))),e.createElement(O,{...P},e.createElement("div",{className:"k-form-field",onMouseEnter:M,onMouseLeave:T},e.createElement(p.Field,{name:"measureAxes",field:"measureAxes",component:H,...K},g.toLanguageString(o.configuratorMeasuresTitle,o.messages[o.configuratorMeasuresTitle]))),n.valueGetter("measureAxes").length?e.createElement(p.Field,{name:"measureAxes",field:"measureAxes",component:J,onMouseEnter:M,onMouseLeave:T,className:"k-column-fields",...Q}):e.createElement("div",{className:"k-settings-description",onMouseEnter:M,onMouseLeave:T},g.toLanguageString(o.configuratorMissingFields,o.messages[o.configuratorMissingFields])))))}),a={data:[],horizontal:!1,fieldsLabel:C.Label,fieldsEditor:ne.PivotGridFieldsEditor,columnAxesLabel:C.Label,columnAxesEditor:v.PivotGridAxesEditor,rowAxesLabel:C.Label,rowAxesEditor:v.PivotGridAxesEditor,measureAxesLabel:C.Label,measureAxesEditor:v.PivotGridAxesEditor,axesEditor:v.PivotGridAxesEditor,onFieldsEditorFieldCheckAction:r=>({type:d.PIVOT_CONFIGURATOR_ACTION.toggleSelection,payload:r.value}),onFieldsEditorFieldExpandAction:r=>({type:d.PIVOT_CONFIGURATOR_ACTION.toggleExpansion,payload:r.value})};w.displayName="KendoReactPivotGridConfiguratorEditor";exports.PivotGridConfiguratorEditor=w;
